*============================《中国工业经济》程序===========================

*说明：由于全样本数据文件过大，"数据sample.dta"仅保留了第一产业的样本。

clear all


**********正文**********


***表1 变量描述性统计***
use "城市层面投资数据.dta",clear
sum OI connect, detail
use "数据.dta",clear
sum NO connect, detail


***表2 城市-城市对层面的回归结果***
use "城市层面投资数据.dta",clear
reghdfe OI connect , absorb(i.tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m1
reghdfe lnOI connect , absorb(i.tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m2
reghdfe connect connect_IV , absorb(i.tie i.cityid#i.year i.subcityid#i.year) cl (tie)
outreg2 using 表2_一阶段.xml, nocons dec(4) adjr2 e(F) addtext (city-city FE, YES,Mcity-Year FE, YES, Scity-Year FE, YES)
ivreghdfe OI (connect=connect_IV) , absorb(i.tie i.cityid#i.year i.subcityid#i.year) cl (tie)
est store m4
ivreghdfe lnOI (connect=connect_IV) , absorb(i.tie i.cityid#i.year i.subcityid#i.year) cl (tie)
est store m5
ivreghdfe p (connect=connect_IV) , absorb(i.tie i.cityid#i.year i.subcityid#i.year) cl (tie)
est store m6
outreg2 [m1 m2 m4 m5 m6] using 表2.xml, nocons dec(4) adjr2 addtext (city-city FE, YES,Mcity-Year FE, YES, Scity-Year FE, YES)


***表3 公司-城市对层面基准回归结果***
use "数据.dta",clear
**Panel A
reghdfe NO connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnNO (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 表3A.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)
**Panel B
reghdfe NO connect if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnNO (connect= connect_IV) if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 表3B.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)
**Panel C
reghdfe NO connect if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnNO (connect= connect_IV) if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 表3C.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)
**Panel D
reghdfe lninvest connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe lninvest (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnrealinvest connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnrealinvest (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 表3D.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***表4 使用事件研究法检验工具变量外生性（公司-城市对层面的样本）***
gen connect_IV_pre8=(Dyear_connect_IV==-8)
gen connect_IV_pre7=(Dyear_connect_IV==-7)
gen connect_IV_pre6=(Dyear_connect_IV==-6)
gen connect_IV_pre5=(Dyear_connect_IV==-5)
gen connect_IV_pre4=(Dyear_connect_IV==-4)
gen connect_IV_pre3=(Dyear_connect_IV==-3)
gen connect_IV_pre2=(Dyear_connect_IV==-2)
gen connect_IV_pre1=(Dyear_connect_IV==-1)
gen connect_IV_post0=(Dyear_connect_IV==0)
gen connect_IV_post1=(Dyear_connect_IV==1)
gen connect_IV_post2=(Dyear_connect_IV==2)
gen connect_IV_post3=(Dyear_connect_IV==3)
gen connect_IV_post4=(Dyear_connect_IV==4)
gen connect_IV_post5=(Dyear_connect_IV>=5&Dyear_connect_IV<100)
reghdfe NO connect_IV_pre8 connect_IV_pre7 connect_IV_pre6 connect_IV_pre5 connect_IV_pre4 connect_IV_pre3 connect_IV_pre2 connect_IV_pre1 connect_IV_post0 connect_IV_post1 connect_IV_post2 connect_IV_post3 connect_IV_post4 connect_IV_post5, absorb(tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m1
reghdfe NO connect_IV_pre8 connect_IV_pre7 connect_IV_pre6 connect_IV_pre5 connect_IV_pre4 connect_IV_pre3 connect_IV_pre2 connect_IV_pre1 connect_IV_post0 connect_IV_post1 connect_IV_post2 connect_IV_post3 connect_IV_post4 connect_IV_post5 if centralcity50 ==0& centralsubcity50 ==0, absorb(tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m2
outreg2  [m1 m2] using 表4.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***表5 异质性分析（工具变量回归）***
**产业
gen connect_ind1=connect*ind1
gen connect_ind2=connect*ind2
gen connect_ind3=connect*ind3
gen connect_IV_ind1=connect_IV*ind1
gen connect_IV_ind2=connect_IV*ind2
gen connect_IV_ind3=connect_IV*ind3
ivreghdfe NO (connect_ind1 connect_ind2 connect_ind3 = connect_IV_ind1 connect_IV_ind2 connect_IV_ind3) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m1
**股权性质
gen connect_soe=connect*SOE
gen connect_nsoe=connect*NSOE
gen connect_IV_soe=connect_IV*SOE
gen connect_IV_nsoe=connect_IV*NSOE
ivreghdfe NO (connect_soe connect_nsoe= connect_IV_soe connect_IV_nsoe ) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
outreg2 [m1 m2] using 表5.xml, nocons dec(4) addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***表7 不对称性检验（工具变量回归）***
**高铁规划的节点城市作为中心城市
gen CC1=1 if  centralcity ==1& centralsubcity ==1
replace CC1=0 if CC1==.
gen CP1=1 if  centralcity ==1& centralsubcity ==0
replace CP1=0 if CP1==.
gen PC1=1 if  centralcity ==0& centralsubcity ==1
replace PC1=0 if PC1==.
gen PP1=1 if  centralcity ==0& centralsubcity ==0
replace PP1=0 if PP1==.
gen connect_CC1=connect*CC1
gen connect_CP1=connect*CP1
gen connect_PC1=connect*PC1
gen connect_PP1=connect*PP1
gen connect_IV_CC1=connect_IV*CC1
gen connect_IV_CP1=connect_IV*CP1
gen connect_IV_PC1=connect_IV*PC1
gen connect_IV_PP1=connect_IV*PP1
ivreghdfe NO (connect_CC1 connect_CP1 connect_PC1 connect_PP1 = connect_IV_CC1 connect_IV_CP1 connect_IV_PC1 connect_IV_PP1) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m1
ivreghdfe lnNO (connect_CC1 connect_CP1 connect_PC1 connect_PP1 = connect_IV_CC1 connect_IV_CP1 connect_IV_PC1 connect_IV_PP1) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
**省会城市和计划单列市作为中心城市
gen CC2=1 if  C_city2 ==1&  C_subcity2 ==1
replace CC2=0 if CC2==.
gen CP2=1 if   C_city2 ==1&  C_subcity2 ==0
replace CP2=0 if CP2==.
gen PC2=1 if   C_city2 ==0&  C_subcity2 ==1
replace PC2=0 if PC2==.
gen PP2=1 if   C_city2 ==0&  C_subcity2 ==0
replace PP2=0 if PP2==.
gen connect_CC2=connect*CC2
gen connect_CP2=connect*CP2
gen connect_PC2=connect*PC2
gen connect_PP2=connect*PP2
gen connect_IV_CC2=connect_IV*CC2
gen connect_IV_CP2=connect_IV*CP2
gen connect_IV_PC2=connect_IV*PC2
gen connect_IV_PP2=connect_IV*PP2
ivreghdfe NO (connect_CC2 connect_CP2 connect_PC2 connect_PP2 = connect_IV_CC2 connect_IV_CP2 connect_IV_PC2 connect_IV_PP2) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m3
ivreghdfe lnNO (connect_CC2 connect_CP2 connect_PC2 connect_PP2 = connect_IV_CC2 connect_IV_CP2 connect_IV_PC2 connect_IV_PP2) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 表7.xml, nocons dec(4) addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***表8 机制检验-市场规模（工具变量回归）***
gen connect_lntotpop=connect* delta_lntotpop
gen connect_IV_lntotpop=connect_IV* delta_lntotpop
ivreghdfe NO (connect connect_lntotpop = connect_IV connect_IV_lntotpop) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m1
gen connect_lnpop=connect* delta_lnpop
gen connect_IV_lnpop=connect_IV* delta_lnpop
ivreghdfe NO (connect connect_lnpop = connect_IV connect_IV_lnpop) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
gen connect_lngdp=connect* delta_lngdp
gen connect_IV_lngdp=connect_IV* delta_lngdp
ivreghdfe NO (connect connect_lngdp = connect_IV connect_IV_lngdp) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m3
outreg2 [m1 m2 m3] using 表8.xml, nocons dec(4) addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***表9 机制检验-产业集聚、科技水平与人力资本（工具变量回归）***
gen connect_lncomp=connect* delta_lncomp
gen connect_IV_lncomp=connect_IV* delta_lncomp
ivreghdfe NO (connect connect_lncomp = connect_IV connect_IV_lncomp) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m1
gen connect_lnzl=connect* delta_lnzl
gen connect_IV_lnzl=connect_IV* delta_lnzl
ivreghdfe NO (connect connect_lnzl = connect_IV connect_IV_lnzl) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
gen connect_edu=connect* delta_edu
gen connect_IV_edu=connect_IV* delta_edu
ivreghdfe NO (connect connect_edu = connect_IV connect_IV_edu) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m3
outreg2 [m1 m2 m3] using 表9.xml, nocons dec(4) addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


**********附录**********


***附图2 2006-2018年上市公司异地子公司的数量***
twoway (bar totalOI year, yaxis(2) barw(0.35) xlabel(2006(1)2018) ytitle(上市公司设立的异地子公司总数) xtitle(年份)) (scatter meanOI year, c(l) yaxis(1) ylabel(0(3)15) ytitle(平均每家上市公司设立的异地子公司数量) saving("附图2", replace))
 
 
***附图4 2006-2018年开通高铁的城市数量及占比***
twoway (bar hsr_city year, yaxis(2) barw(0.35) xlabel(2006(1)2018) ytitle(开通高铁的城市个数) xtitle(年份)) (scatter hsr_percent year, c(l) yaxis(1) ytitle(开通高铁的城市占比（100%）) saving("附图4", replace))


***附图5 2006-2018年城市-城市对层面开通高铁占比***
scatter connect_percent year, c(l) xlabel(2006(1)2018) ytitle( 城市-城市对层面开通高铁占比（100%）) xtitle(年份) saving("附图5", replace)


***附表1 稳健性检验（包含省直辖县和新疆生产建设兵团所辖县样本）***
**城市-城市对层面稳健性检验
use "稳健性检验_城市层面.dta",clear
reghdfe OI connect , absorb(i.tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m1
reghdfe lnOI connect , absorb(i.tie i.cityid#i.year i.subcityid#i.year) vce (cl tie)
est store m2
reghdfe connect connect_IV , absorb(tie i.cityid#i.year i.subcityid#i.year) cl (tie)
outreg2 using 附表1_一阶段.xml, nocons dec(4) adjr2 e(F) addtext (city-city FE, YES,Mcity-Year FE, YES, Scity-Year FE, YES)
ivreghdfe OI (connect=connect_IV) , absorb(tie i.cityid#i.year i.subcityid#i.year) cl (tie)
est store m4
ivreghdfe lnOI (connect=connect_IV) , absorb(tie i.cityid#i.year i.subcityid#i.year) cl (tie)
est store m5
outreg2 [m1 m2 m4 m5]using 附表1.xml, nocons dec(4)adjr2 addtext (city-city FE, YES,Mcity-Year FE, YES, Scity-Year FE, YES)
**公司-城市对层面稳健性检验
use "稳健性检验_公司层面.dta",clear
*Panel A
reghdfe NO connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe NO (connect= connect_IV) ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 附表1A.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)
*Panel B
reghdfe NO connect if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnNO (connect= connect_IV) if centralcity ==0& centralsubcity ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 附表1B.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)
*Panel C
reghdfe NO connect if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m1
ivreghdfe NO (connect= connect_IV) if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m2
reghdfe lnNO connect if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
est store m3
ivreghdfe lnNO (connect= connect_IV) if centralcity50 ==0& centralsubcity50 ==0,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) cl (tie)
est store m4
outreg2 [m1 m2 m3 m4] using 附表1C.xml, nocons dec(4) adjr2 addtext (Firm-Scity FE, YES,Firm-Year FE, YES, Scity-Year FE, YES)


***附图6 安慰剂检验估计系数的分布***
forvalues i=1(1)500 {

use placebo,clear
save connect_data,replace
use connect_data,clear 
save dummy_data,replace

*****************************************
use dummy_data,clear
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 30, count
keep year tie
rename year connect_year
save connect_time,replace
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 212, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
***************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 173, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
******************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 225, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*******************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 803, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
******************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 210, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 152, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 1219, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 1867, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 1775, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 2268, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 2322, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
bysort year:keep if _n==1
sample 1, count
keep year
save temp,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==3
drop _merge
sample 1076, count
keep year tie
rename year connect_year
save connect_temp, replace
append using connect_time
save connect_time,replace
use connect_temp,clear
keep tie
save connect_drop,replace

use dummy_data,clear
merge m:1 year using temp
keep if _merge==1
drop _merge
merge m:1 tie using connect_drop
keep if _merge==1
drop _merge
save dummy_data,replace
*****************************************
use connect_time
merge 1:m tie using connect_data
drop _merge
replace connect_year=2020 if connect_year==.
gen false_connect=(connect_year-year<=0)
save connect_data,replace

use "investment_data.dta",clear
merge m:1 tie year using connect_data
keep if _merge==3
drop _merge
reghdfe NO false_connect ,absorb(i.stkcd#i.subcityid i.stkcd#i.year i.subcityid#i.year) vce (cl tie)
parmest,format (estimate min95 max95 %8.4f p %8.3f) saving("temp.dta", replace)
use "temp.dta", clear
keep if parm=="false_connect"
append using "connect_simulations.dta"
save "connect_simulations",replace
}

erase "temp.dta"
use "connect_simulations.dta", clear
drop if estimate==.
save "connect_simulations.dta", replace

dpplot estimate,xtitle("安慰剂检验的估计系数") ytitle("概率密度") saving("附图6", replace)


***end